/****************************************************************************/
/** syringe95.cpp                                                          **/
/** ---------------------------------------------------------------------- **/
/** Injects custom dll into specified process (under Win95/98)             **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1998-99, OK Thinking Software                            **/
/** ---------------------------------------------------------------------- **/
/** This library is free software; you can redistribute it and/or          **/
/** modify it under the terms of the GNU Lesser General Public             **/
/** License as published by the Free Software Foundation; either           **/
/** version 2 of the License, or (at your option) any later version.       **/
/**                                                                        **/
/** This library is distributed in the hope that it will be useful,        **/
/** but WITHOUT ANY WARRANTY; without even the implied warranty of         **/
/** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      **/
/** Lesser General Public License for more details.                        **/
/**                                                                        **/
/** You should have received a copy of the GNU Lesser General Public       **/
/** License along with this library; if not, write to the Free Software    **/
/** Foundation,Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA **/
/** ---------------------------------------------------------------------- **/
/**                                  Oleg Kagan (oleg_kagan@geocities.com) **/
/** ---------------------------------------------------------------------- **/
/** History:           (see history.txt file for complete project history) **/
/**                                                                        **/
/** August 13, 1999 - Version 1.0.7.0                                      **/
/**                                  Oleg Kagan (oleg_kagan@geocities.com) **/
/****************************************************************************/

//============================================================================
#if !((defined(WIN32)||defined(WIN64)) && defined(_SYRINGE_WIN9X_COMPATIBLE_))
	#error syringe95.cpp can be compiled for Win32 platform with \
_SYRINGE_WIN9X_COMPATIBLE_ defined only!
#endif // !(defined(WIN32) && defined(_SYRINGE_WIN9X_COMPATIBLE_))

// Switch all optimizations off 
// (Visual C specific... For any other compiler do the same thing)
//============================================================================
#ifdef _MSC_VER
	#pragma optimize("", off)
#endif // defined(_MSC_VER)

//============================================================================
#include <windows.h>
#pragma hdrstop

//============================================================================
#include "syringex.h"

//============================================================================
#define SYRINGE95_INJECT_TOOLS_PTR_DEFAULT 0x77777777L
#define SYRINGE95_INJECT_TOOLS_END_FLAG 0
#define SYRINGE95_INJECT_TOOLS_RESULT 1

//============================================================================
extern void WINAPI InjectorThread95();
extern void InjectorThreadEnd95(); 

//============================================================================
bool ChangeInjectToolsAddress(
	
	void* pStart, 
	size_t nLength,
	void* pNewValue

){
	char* p_cSearch = (char*)pStart;
	char* p_cEnd = (p_cSearch + nLength) - sizeof(void*);

	while (
		(p_cSearch <= p_cEnd) && 
		(*(void**)p_cSearch != (void*)SYRINGE95_INJECT_TOOLS_PTR_DEFAULT)
	) ++p_cSearch;

	if (p_cSearch <= p_cEnd) {
		*(void**)p_cSearch = pNewValue;
		return true;
	} /*if*/

	return false;
} /*ChangeInjectToolsAddress(void*, size_t, void*)*/

//----------------------------------------------------------------------------
void* PrepareInjectorCode(

	void* pInjectTools

){
	const size_t nInjectorCodeSize = (
		(char*)&InjectorThreadEnd95 - (char*)&InjectorThread95
	) /*nInjectorCodeSize*/;

	void* pInjectorCode = LocalAlloc(LMEM_FIXED, nInjectorCodeSize + 1);
	if (!pInjectorCode) return NULL;

	memcpy(pInjectorCode, &InjectorThread95, nInjectorCodeSize);

	if (
		!ChangeInjectToolsAddress(
			pInjectorCode, nInjectorCodeSize, pInjectTools
		) /*!ChangeInjectToolsAddress*/
	){
		LocalFree(pInjectorCode); pInjectorCode = NULL;
	} /*iff*/

	return pInjectorCode;
} /*PrepareInjectorCode(void*)*/

//----------------------------------------------------------------------------
void DeleteInjectorCode(

	void* pInjectorCode
	
){
	if (!pInjectorCode) LocalFree(pInjectorCode);
} /*DeleteInjectorCode(void*)*/

//============================================================================
void InjectModuleCleanup95(

	HANDLE hInstrumentalThread,
	CONTEXT& r_InitialContext,
	DWORD dwInitialSuspendCount

){
	DWORD dwCurrentSuspendCount = SuspendThread(hInstrumentalThread);
	if (dwCurrentSuspendCount == 0xFFFFFFFF) return;
	++dwCurrentSuspendCount;

	if (r_InitialContext.ContextFlags)
		SetThreadContext(hInstrumentalThread, &r_InitialContext);

	if (dwCurrentSuspendCount < dwInitialSuspendCount) {
		do {
			dwCurrentSuspendCount = SuspendThread(hInstrumentalThread);
		}
		while (
			(dwCurrentSuspendCount != 0xFFFFFFFF) &&
			(dwCurrentSuspendCount + 1 < dwInitialSuspendCount)
		) /*do*/;
	} 
	else if (dwCurrentSuspendCount > dwInitialSuspendCount) {
		do {
			dwCurrentSuspendCount = ResumeThread(hInstrumentalThread);
		}
		while (
			(dwCurrentSuspendCount != 0xFFFFFFFF) &&
			(dwCurrentSuspendCount > dwInitialSuspendCount + 1)
		) /*do*/;
	} /*iff*/
} /*InjectModuleCleanup95(HANDLE, CONTEXT&, DWORD)*/

//----------------------------------------------------------------------------
BOOL WINAPI InjectModule95(

	HANDLE hProcess, 
	HANDLE hInstrumentalThread,
	const char* c_szModuleToInject,
	const char* c_szEntryPoint,
	void* pParameter, 
	size_t nParameterSize,
	void** p_pResult,
	DWORD dwTimeOutMSec

){
#ifdef NEVER // Doesn't have meaning if called from syringe.cpp::InjectModuleA
	if (
		!hProcess ||
		!c_szModuleToInject || !*c_szModuleToInject ||
		!c_szEntryPoint || !*c_szEntryPoint
	) return FALSE;

	if (!pParameter || !nParameterSize) {
		pParameter = NULL; 
		nParameterSize = 0;
	} /*if*/
#endif // NEVER
	
	if (!hInstrumentalThread) return FALSE;

	size_t nInjectorCodeSize = (
		(char*)&InjectorThreadEnd95 - (char*)&InjectorThread95
	) /*nInjectorCodeSize*/;

	size_t nInjectToolsSize = sizeof(TInjectTools);

	size_t nInjectorSize = (
		nInjectorCodeSize + nInjectToolsSize + nParameterSize + 128
	) /*nInjectorSize*/;

	DWORD dwInitialSuspendCount = SuspendThread(hInstrumentalThread);
	if (dwInitialSuspendCount == 0xFFFFFFFF) {
		dwSyringeLastError = GetLastError();
		return FALSE;
	} /*if*/

	CONTEXT InitialContext; memset(&InitialContext, 0, sizeof(CONTEXT));

	try {
		InitialContext.ContextFlags = ~InitialContext.ContextFlags;
		if (!GetThreadContext(hInstrumentalThread, &InitialContext)) {
			dwSyringeLastError = GetLastError();
			InitialContext.ContextFlags = 0;
			throw TXInjectorFailure();
		} /*if*/

		void* pInjectorEnd = (void*)(InitialContext.Esp - 4);

		MEMORY_BASIC_INFORMATION MemInfo;
		if (
			VirtualQueryEx(
				hProcess, pInjectorEnd, &MemInfo, sizeof(MemInfo)
			) /*VirtualQueryEx*/ != sizeof(MemInfo)
		){
			dwSyringeLastError = GetLastError();
			throw TXInjectorFailure();
		} /*iff*/

		if (
			(size_t(pInjectorEnd) - size_t(MemInfo.BaseAddress)) <= 
				(nInjectorSize + 512)
		){
			dwSyringeLastError = GetLastError();
			throw TXInjectorFailure();
		} /*if*/

		void* pInjectorStart = (void*)(size_t(pInjectorEnd) - nInjectorSize);
		void* pInjectorCode = pInjectorStart;
		void* pInjectTools = (void*)(
			size_t(pInjectorCode) + nInjectorCodeSize
		) /*pInjectTools*/;
		void* pRemoteParameter = (void*)(
			size_t(pInjectTools) + nInjectToolsSize
		) /*pRemoteParameter*/;

		TInjectTools InjectTools(
			c_szModuleToInject, c_szEntryPoint, 
			pRemoteParameter, nParameterSize
		) /*InjectTools*/;

		// Transfer injector code
		//------------------------
		{
			void* pLocalInjectorCode = PrepareInjectorCode(pInjectTools);
			if (!pLocalInjectorCode) {
				dwSyringeLastError = GetLastError();
				throw TXInjectorFailure();
			} /*if*/

			SIZE_T dwCopied;
			if (
				!WriteProcessMemory(
					hProcess, pInjectorCode, 
					pLocalInjectorCode, nInjectorCodeSize, 
					&dwCopied
				) /*!WriteProcessMemory*/
			){
				dwSyringeLastError = GetLastError();
				DeleteInjectorCode(pLocalInjectorCode); 
				pLocalInjectorCode = NULL;
				throw TXInjectorFailure();
			} /*if*/
			DeleteInjectorCode(pLocalInjectorCode); 
			pLocalInjectorCode = NULL;
		} /*Transfer injector code*/

		// Transfer inject tools
		//-----------------------
		{
			SIZE_T dwCopied;
			if (
				!WriteProcessMemory(
					hProcess, pInjectTools, &InjectTools, nInjectToolsSize, 
					&dwCopied
				) /*!WriteProcessMemory*/
			){
				dwSyringeLastError = GetLastError();
				throw TXInjectorFailure();
			} /*if*/
		} /*Transfer inject tools*/

		// Transfer parameters
		//---------------------
		if (pParameter) {
			SIZE_T dwCopied;
			if (
				!WriteProcessMemory(
					hProcess, pRemoteParameter, 
					pParameter, nParameterSize, 
					&dwCopied
				) /*!WriteProcessMemory*/
			){
				dwSyringeLastError = GetLastError();
				throw TXInjectorFailure();
			} /*if*/
		} /*Transfer parameters*/

		// Start injector
		//----------------
		{
			CONTEXT InjectContext; 
			memcpy(&InjectContext, &InitialContext, sizeof(CONTEXT));
			InjectContext.Esp = size_t(pInjectorStart);
			InjectContext.Eip = size_t(pInjectorCode);

			if (!SetThreadContext(hInstrumentalThread, &InjectContext)) {
				dwSyringeLastError = GetLastError();
				throw TXInjectorFailure();
			} /*if*/

			while (ResumeThread(hInstrumentalThread) > 1);
		} /*Start injector*/

		// Wait until injector complete
		//------------------------------
		{
			char a_cDummy[2]; memset(a_cDummy, 0, sizeof(a_cDummy));
			char* pRemoteDummy = (
				((TInjectTools*)pInjectTools)->a_cDummy + 
					SYRINGE95_INJECT_TOOLS_END_FLAG
			) /*pRemoteDummy*/;

			DWORD dwStartTick = GetTickCount();
			DWORD dwCopied;
			do {
				// Check for timeout
				//-------------------
				{
					DWORD dwCurrentTick = GetTickCount();
					if (dwCurrentTick < dwStartTick) { 
						dwStartTick = dwCurrentTick;
					}
					else if ((dwCurrentTick - dwStartTick) > dwTimeOutMSec) {
						dwSyringeLastError = WAIT_TIMEOUT;
						throw TXInjectorFailure();
					} /*iff*/
				} /*Check for timeout*/
				
				Sleep(100);
				ReadProcessMemory(
					hProcess, pRemoteDummy, a_cDummy, 1, &dwCopied
				) /*ReadProcessMemory*/;
			} while (!*a_cDummy);
		} /*Wait until injector complete*/

		SuspendThread(hInstrumentalThread);  // Previous suspend count is 0

		// Read results of the execution
		//-------------------------------
		{
			DWORD dwBytesReaded;
			if (
				!ReadProcessMemory(
					hProcess, pInjectTools, 
					&InjectTools, nInjectToolsSize, &dwBytesReaded
				) /*!ReadProcessMemory*/ 
			){
				dwSyringeLastError = GetLastError(); 
				return FALSE;
			} /*if*/

			if (pParameter) {
				if (
					!ReadProcessMemory(
						hProcess, pRemoteParameter, 
						pParameter, nParameterSize, &dwBytesReaded
					) /*!ReadProcessMemory*/ 
				){
					dwSyringeLastError = GetLastError(); 
					return FALSE;
				} /*if*/
			} /*if*/
		} /*Read results of the execution*/

		if (p_pResult) *p_pResult = InjectTools.pResult;

		DWORD dwInjectorThreadExitCode = *(DWORD*)(
			InjectTools.a_cDummy + SYRINGE95_INJECT_TOOLS_RESULT
		) /*dwInjectorThreadExitCode*/;

		if (!dwInjectorThreadExitCode) {
			dwSyringeLastError = InjectTools.dwLastError; 
			throw TXInjectorFailure();
		} /*if*/
	} /*try*/
	catch (TXInjectorFailure&) {
		InjectModuleCleanup95(
			hInstrumentalThread, InitialContext, dwInitialSuspendCount
		) /*InjectModuleCleanup95*/;
		return FALSE;
	} /*catch (TXInjectorFailure&)*/
	catch (...) {
		InjectModuleCleanup95(
			hInstrumentalThread, InitialContext, dwInitialSuspendCount
		) /*InjectModuleCleanup95*/;
		throw;
	} /*catch (...)*/

	InjectModuleCleanup95(
		hInstrumentalThread, InitialContext, dwInitialSuspendCount
	) /*InjectModuleCleanup95*/;

	return TRUE;
} /*InjectModule95(HANDLE, HANDLE, const char*, const char*, void*, ...)*/

// Switch off all stack checks
// (Visual C specific... For any other compiler do the same thing)
//============================================================================
#ifdef _MSC_VER
	#pragma check_stack (off)
#endif // defined(_MSC_VER)

//============================================================================
static void WINAPI InjectorThread95()
{
	TInjectTools* pInjectTools;
	TLoadCustomDllPtr p_fnLoadCustomDllPtr;
	DWORD dwResult = FALSE;
	
	_asm {
		mov pInjectTools, SYRINGE95_INJECT_TOOLS_PTR_DEFAULT
	} /*_asm*/

	if (
		!pInjectTools ||
		!pInjectTools->p_fnLoadLibraryA || !pInjectTools->p_fnFreeLibrary ||
		!pInjectTools->p_fnGetProcAddressA || 
		!pInjectTools->p_fnGetLastError ||
		!pInjectTools->p_fnOutputDebugStringA
	) goto End;

	// Load syringe.dll
	//------------------
	pInjectTools->hSyringe = pInjectTools->p_fnLoadLibraryA(
		pInjectTools->szSyringeFullName
	) /*pInjectTools->hSyringe*/;
	if (!pInjectTools->hSyringe) {
		pInjectTools->dwLastError = pInjectTools->p_fnGetLastError(); 
		goto End;
	} /*if*/

	// Call LoadCustomDll from syringe.dll (see syringe.cpp)
	//-------------------------------------------------------
	p_fnLoadCustomDllPtr = TLoadCustomDllPtr(
		pInjectTools->p_fnGetProcAddressA(
			pInjectTools->hSyringe, pInjectTools->szLoadCustomDll
		) /*pInjectTools->p_fnGetProcAddressA*/
	) /*p_fnLoadCustomDllPtr*/;
	if (!p_fnLoadCustomDllPtr) {
		pInjectTools->dwLastError = pInjectTools->p_fnGetLastError(); 
		goto End;
	} /*if*/

	dwResult = p_fnLoadCustomDllPtr(*pInjectTools);

	pInjectTools->p_fnFreeLibrary(pInjectTools->hSyringe);
	pInjectTools->hSyringe = NULL;

End:
	// Save result
	//-------------
	*(DWORD*)(pInjectTools->a_cDummy + SYRINGE95_INJECT_TOOLS_RESULT) = 
		dwResult;

	// Set completion flag and wait for suspend
	//------------------------------------------
	pInjectTools->a_cDummy[SYRINGE95_INJECT_TOOLS_END_FLAG] = 1;
	while (true); 
} /*InjectorThread95()*/

//============================================================================
static void InjectorThreadEnd95() {}; 

// Switch all stack checks to the original state
// (Visual C specific... For any other compiler do the same thing)
//============================================================================
#ifdef _MSC_VER
	#pragma check_stack
#endif // defined(_MSC_VER)
